/*
 * mns v.68beta
 * Multifuctional Network Scanner
 * bind & aempirei 04/99
 *
 *
 * usage:
 *  ./mns <file> [options...]
 *
 */

#include "mns.h"

extern void vuln (char *, int, int, int);

int usage (char *arg);

struct iplist *localiplist;

void 
main (int argc, char *argv[])
{
  struct iplist *iplwalk;
  int children = 30;		/* number of processes to fork */
  int opt;			/* file descriptor for getopt() */
  int port = 0;			/* default port for domain scan */
  u_long vulnscans = 0;
  int iprslv = 0;

  extern char *optarg;		/* optarg for getopt */
  extern int opterr;		/* opterr for getopt */

  char *file;

  file = argv[1];

  setvbuf (stdout, NULL, _IONBF, 0);

  if (argc < 2)
    usage (argv[0]);

  opterr = 0;
  while ((opt = getopt (argc, argv, "RAfqincrC:V")) != -1)
    {
      switch (opt)
	{
	 case 'R':
	   iprslv = 1;
	   break;
	case 'A':
	   vulnscans = ~RESOLVE;
	   break;
 	case 'q':
	  vulnscans |= VULNQPOP;
	  break;
	case 'i':
	  vulnscans |= VULNIMAP;
	  break;
	case 'n':
	  vulnscans |= VULNNLPS;
	  break;
	case 'f':
	  vulnscans |= VULNFTP;
	  break;
	case 'c':
	  vulnscans |= VULNCGI;
	  break;
	case 'r':
	  vulnscans |= VULNRPC;
	  break;
	case 'C':
	  children = atoi (optarg);
	  break;
	case 'V':
	  puts (VERSION);
	  exit (0);
	  break;
	case '?':
	  usage (argv[0]);
	  break;
	}
    }
   
   if(iprslv) vulnscans |= RESOLVE;

  if ((children < 2) || (children > 200))
    {
      puts ("ERROR: invalid number of children");
      usage (argv[0]);
    }

  printf ("**********************************************************************\n");
  printf ("                  %s (c) 1999 bind & aempirei\n", VERSION);
  printf ("**********************************************************************\n\n");
  
  setuid(0);
  localiplist = iplwalk = getlocalips ();
  
   putchar('\n');
   
  if(localiplist == NULL) {
     puts(" * no usable interfaces were detected");
     exit(0);
  }
   
  if(getuid()) {
     puts(" * user does not have root privilages");
     exit(0);
  }
   
  vuln (file, children, vulnscans, port);

  putchar ('\n');
}

int 
usage (char *program)
{
  printf ("**********************************************************************\n");
  printf ("                  %s (c) 1999 bind & aempirei\n", VERSION);
  printf ("**********************************************************************\n\n");
  printf (" usage: %s <file> [options...]\n", program);
  printf ("   <file>           file containing IP Addresses and hostnames\n"
  	  "   [-qinfcr]        enable vulnerability checks which consist of\n"
	  "                    the following vulnerability scanning options\n"
	  "                       -q  QPOP\n"
	  "                       -i  IMAP\n"
	  "                       -n  NLPS\n"
	  "                       -f  FTP\n"
	  "                       -c  CGI\n"
	  "                       -r  RPC\n"
 	  "   [-C <children>]  set maximum child processes (2-200)\n"
	  "   [-V]             display version information\n"
          "   [-R]             try to resolve IPs to hostnames\n"
          "   [-A]             enable all vulerability checks\n\n");
  exit (1);
}
