#include "mns.h"

#define ACK_RAND 200
#define Zzz 100
#define PKS 8

void init_tcpip(int *, int *);
void sendtcp(int, hdrinfo *, u_short, short);
short gettcp(int, hdrinfo *, struct tcphdr *, u_short);
char *checkosmain(int, int, SAin, SAin, short);

struct OSRES {
   u_short set:2,
           seq:2,
           ackset:3,
           urg:1;
   u_long ack;
   u_short win;
   u_short flag;
};

void main(int argc, char *argv[]) {
  SAin dest, from;
  int sd_send, sd_recv;
  
  int i, port;
#define usage(a)\
   {printf("usage: %s <source> <destination> <port>\n", argv[0]);\
   exit(0);}
   
  if(argc < 4) usage(argv[0]);
  
  init_tcpip (&sd_send, &sd_recv);
  setvbuf (stdout, NULL, _IONBF, 0);

  bzero (&dest, sizeof (SAin));
  bzero (&from, sizeof (SAin));

  if(!ipv4_rslvhost(argv[1], &from)) { puts("bad source"); usage(argv[0]) };
  if(!ipv4_rslvhost(argv[2], &dest)) { puts("bad destination"); usage(argv[0]) };
  if(!atoi(argv[3])) { puts("bad port"); usage(argv[0]); }

  checkosmain (sd_send, sd_recv, from, dest, atoi(argv[3]));

  close (sd_send);
  close (sd_recv);
}

char *checkosmain (int sd_send, int sd_recv,
 	           SAin from, SAin dest, short dport) {
   FILE *fs_cfg;
   char *osname;
   struct OSRES r[PKS];
   struct tcphdr tcp;
   hdrinfo spoof;
   u_short start, s;
   u_long myseq[PKS];
   u_long seq_mask = 0L;
   long timeout;
   char line[1024];
   int n;

   for (n = 0; n < PKS; n++)
      bzero(&r[n], sizeof(struct OSRES));

   srand(time(NULL));
   start = s = (u_short)getpid() + 5000 + (rand() % 5000);
   spoof.ack = 0;
   spoof.from = from;
   spoof.dest = dest;
   spoof.dport = dport;

#define sendtcppacket(a, b)\
   {spoof.seq = myseq[a] = rand();\
   spoof.sport = start + a;\
   sendtcp(sd_send, &spoof, (b), 1);\
   usleep(10);}\

  sendtcppacket (0, SYN);
  sendtcppacket (1, SYN | ACK);
  sendtcppacket (2, FIN);
  sendtcppacket (3, FIN | ACK);
  sendtcppacket (4, SYN | FIN);
  sendtcppacket (5, PSH);
  sendtcppacket (6, SYN | XXX | YYY);
  sendtcppacket (7, SYN);

  timeout = time (NULL) + TIMEOUT;
  n = 0;
  printf("( src->SYN :: dest->ACK :: dest->SYN )\n");

  while ((timeout > time (NULL)) && n != PKS - 1) {
     if (gettcp(sd_recv, &spoof, &tcp, start)) {
              n = ntohs(tcp.th_dport) - start;

	      if(n < 0 || n >= PKS) continue;
              if(r[n].set) continue;
              
	      if(!n && !ntohs(tcp.th_win)) printf("< closed port >\n");
              
              printf("( %08lx :: %08lx :: %08lx )\n",
		     myseq[n], ntohl(tcp.th_ack), ntohl(tcp.th_seq));
                     
              r[n].seq = (tcp.th_seq != 0);
	      if(r[n].seq) seq_mask ^= tcp.th_seq;
              r[n].ack = ntohl(tcp.th_ack);
              r[n].ackset = (tcp.th_ack != 0);
              if(r[n].ackset && (myseq[n] > r[n].ack))
                 r[n].ackset = 2;
              if(r[n].ackset) r[n].ack = (myseq[n] < r[n].ack) ?
                                         (r[n].ack - myseq[n]) :
                                         (myseq[n] - r[n].ack);
              if(r[n].ack > ACK_RAND) {
                 r[n].ackset = 3;
                 r[n].ack = 0;
              }
              r[n].win = ntohs(tcp.th_win);
              r[n].flag = tcp.th_flags;
              r[n].set = 1;
              r[n].urg = (tcp.th_urp != 0);
     }
     usleep (Zzz);
  }
  printf("sequence mask { %08lx }\n", seq_mask);
  printf("hamming distance { %u }\n", hamming(seq_mask));
  putchar('\n');

printf("* New Fingerprint\n");
for(n = 0; n < PKS - 1; n++) {
   if(r[n].set) {
        printf("%i %i ", n, r[n].seq);
           switch(r[n].ackset) {
           case 0: putchar('N'); break;
           case 1: putchar('+'); printf("%li", r[n].ack); break;
           case 2: putchar('-'); printf("%li", r[n].ack); break;
           case 3: putchar('R'); break;
           }
           
        printf(" %04x ", r[n].win);
        if(r[n].flag & SYN) putchar('S');
        if(r[n].flag & RST) putchar('R');
        if(r[n].flag & ACK) putchar('A');
        if(r[n].flag & FIN) putchar('F');
        if(r[n].flag & PSH) putchar('P');
        if(r[n].flag & XXX) putchar('X');
        if(r[n].flag & YYY) putchar('Y');
        if(r[n].urg) putchar('U');
        putchar('\n');
   } else printf("%i - - - -\n", n);
}
putchar('\n');
}

/* Sends a TCP packet */
void sendtcp (int sd_send, hdrinfo * spoof, u_short flags, short rep) {
  struct tcphdr tcp;
  struct ip ip;
  static char pkt[8192];
  int i;

/*-- IP HDR --*/
  ip.ip_hl = 5;
  ip.ip_v = 4;
  ip.ip_tos = 0;
  ip.ip_len = htons(40);
  ip.ip_id = htons(rand() % 0xffff);
  ip.ip_off = 0;
  ip.ip_ttl = 200 + (rand() % 56);
  ip.ip_p = IPPROTO_TCP;
  ip.ip_src = spoof->from.sin_addr;
  ip.ip_dst = spoof->dest.sin_addr;
#ifdef HAVE_STRUCT_IP_CSUM
#define ip_sum ip_csum
#endif
  ip.ip_sum = 0;
  ip.ip_sum = in_cksum((u_short *)&ip, sizeof(struct ip));

/*-- TCP HDR --*/
  tcp.th_sport = htons(spoof->sport);
  tcp.th_dport = htons(spoof->dport);
  tcp.th_seq = htonl(spoof->seq);
  tcp.th_ack = 0;
#ifdef X2_OFF
  tcp.th_x2_off = 0x50;
#else
  tcp.th_x2 = 0;
  tcp.th_off = 5;
#endif
  tcp.th_flags = flags;
  tcp.th_win = htons(0x1000 | (rand() % 0x1000));
  tcp.th_urp = 0;
  tcp.th_sum = 0;

/*-- TCP Checksum --*/
#ifdef SOLARIS_CKSUM_BUG
  tcp.th_sum = sizeof(struct tcphdr);
#else
  tcp.th_sum = tcp_cksum((char *)&tcp,
			 sizeof (struct tcphdr),
			 spoof->from.sin_addr,
			 spoof->dest.sin_addr);
#endif /* SOLARIS_CKSUM_BUG */

  memcpy (pkt, &ip, sizeof(ip));
  memcpy (pkt + sizeof(ip), &tcp, sizeof(tcp));

  for (i = 0; i < rep; i++)
     if (sendto (sd_send, pkt,
                 40, 0, (SA *)&spoof->dest,
                 sizeof(spoof->dest)) < 0)
        perror ("sending message");

}

/* Get's a TCP packet */
#define MAXSIZE	65535

short gettcp(int sd_recv, hdrinfo *spoof, struct tcphdr *dtcp, u_short sseq) {
   char packet[MAXSIZE];
#define tcphd ((struct tcphdr *)&packet[20])
#define iphd  ((struct ip *)packet)
  
   if(read(sd_recv, packet, MAXSIZE) < 0) return 0;

   /* Check to see if it's a TCP/IP correct host
    * and port from this process */
   
   if(spoof->dest.sin_addr.s_addr != iphd->ip_src.s_addr) return 0;
   if(htons(spoof->dport) != tcphd->th_sport) return 0;
   if(ntohs(tcphd->th_dport) - sseq >= PKS) return 0;
   
   memcpy(dtcp, tcphd, sizeof(struct tcphdr));
   return 1;
}

void init_tcpip (int *sd_send, int *sd_recv) {
   int on = 1;
   int rsflags;

/*-- SEND RAW socket --*/
   if ((*sd_send = socket(AF_INET, SOCK_RAW, IPPROTO_RAW)) < 0) {
      perror ("opening raw send socket");
      exit (EXIT_FAILURE);
   }
   if (setsockopt(*sd_send, IPPROTO_IP, IP_HDRINCL, &on, sizeof(on)) < 0) {
      perror("setting option IP_HDRINCL");
      exit (EXIT_FAILURE);
   }

/*-- READ RAW socket --*/
   if((*sd_recv = socket(AF_INET, SOCK_RAW, IPPROTO_TCP)) < 0) {
      perror ("opening raw read socket");
      exit (EXIT_FAILURE);
   }
   if((rsflags = fcntl(*sd_recv, F_GETFL)) == -1) {
      perror ("fcntl(sd_recv,F_GETFL)");
      exit (EXIT_FAILURE);
   }
   if (fcntl(*sd_recv, F_SETFL, rsflags | O_NONBLOCK) == -1) {
      perror ("fcntl(sd_recv,F_SETFL)");
      exit (EXIT_FAILURE);
   }
}
   
