#include "mns.h"

FILE *in_file;

void scan (struct in_addr, u_long);

void  vuln (char *file, int children, u_long vulnscans) {
  static char host[60];
  static int i, status;

  SAin vuln;
  int ff;

  /* open file */
  in_file = fopen (file, "r");

  if (in_file == NULL)
    {
      printf ("error: cannot open %s\n", file);
      exit (EXIT_FAILURE);
    }

  printf ("Reading hosts from: %s\n", file);

  for (i = 0; i < children; i++)
    {
      fgets (host, 60, in_file);
      if (feof (in_file))
	break;

      host[strlen (host) - 1] = '\0';	/* fgets keeps the linefeed */

      if (ipv4_rslvhost (host, &vuln))
	{
	  if (!(ff = fork ()))
	    {
	      scan (vuln.sin_addr, vulnscans);
	      exit (0);
	    }
	  else if (ff == -1)
	    printf ("fork failed!\n");
	}
      else
	printf ("parse error: skipping '%s'\n", host);
    }

  if (!feof (in_file))
    {
      for (;;)
	{
	  wait (&status);

	  fgets (host, 32, in_file);
	  if (feof (in_file))
	    break;

	  host[strlen (host) - 1] = '\0';	/* fgets keeps the linefeed */

	  if (ipv4_rslvhost (host, &vuln))
	    {
	      if (!(ff = fork ()))
		{
		  scan (vuln.sin_addr, vulnscans);
		  exit (0);
		}
	      else if (ff == -1)
		printf ("fork failed!\n");
	    }
	  else
	    printf ("parse error: skipping '%s'\n", host);
	}
    }

  fclose (in_file);

  while (!((waitpid (-1, &status, WNOHANG) == -1) && (errno == ECHILD)));
}

void  scan (struct in_addr hostip, u_long vopts) {
  struct node *node1st, *walk, *ntemp;
  char hostname[60];
  int *portlist = NULL;
  int i, pcount;

  node1st = walk = calloc (sizeof (struct node), 1);

  /*if (vopts & PORTSCAN)*/ walk = stealthscan (hostip, walk, &portlist);
  /*if (vopts & OSDETECT)*/ walk = checkos (hostip, walk, portlist);

   if(portlist != NULL) {
      pcount = portlist[0] + 1;
      for(i = 1; i < portlist[0] + 1; i++) {
	 switch (portlist[i]) {
	  case   21: if (vopts & VULNFTP)  walk = ftp (hostip, walk); break;
	  case  110: if (vopts & VULNQPOP) walk = qpop (hostip, walk); break;
	  case  143: if (vopts & VULNIMAP) walk = imap (hostip, walk); break;
	  case 2766: if (vopts & VULNNLPS) walk = nlps (hostip, walk); break;
	  case   80: if (vopts & VULNCGI)  walk = cgi (hostip, walk); break;
	  case  111: if (vopts & VULNRPC)  walk = rpc (hostip, walk); break;
	 }
      }
   }

  if (node1st->next != NULL)
    {
      printf ("\nHost: %s", (vopts & RESOLVE) ?
	      ipv4_showname (AF_INET,&hostip,hostname,60) :
	      inet_ntoa(hostip));
      for (walk = node1st; walk->next != NULL; walk = walk->next)
	printf (" %s", walk->string);
      putchar ('\n');
    }

  for (walk = node1st; walk != NULL;)
    {
      ntemp = walk->next;
      free (walk);
      walk = ntemp;
    }
}
